unit mpxfmenu;
{
  MPXT Menus.
  This was rewritten for the last versions (of MPXF).
  It uses MPXTMENU.CFG to parse the menus, which can be dynamic.
}


interface
  uses mpxfvars;

procedure SearchMenu;
procedure PlayListMenu;
procedure SetupMenu;
procedure DatabaseMenu;
procedure CDAudioMenu;
procedure IRMenu;
implementation

uses {mpxfvars,}lcd,crt,mpxfsrch,mpxfpl,mpxfgen,mpxfdb,mpxfcd,config,mpxfir,mpxfcprc;


{getirfilename}
{procedure AddData(var data:string);}
{function MenuSelect(TheMenu:menu; choices:integer) : integer;}

{quitplayer}
{processmenu}


{menuloop}

{loadmenu}

procedure SearchMenu;
  var sch:integer;
      inp:string;
      code:integer;
      iSong:word;
      smenu:^menu;
      i:integer;

  begin
    repeat

      LCDClear;
      LCDCursorOff;
      new(smenu);
      smenu^[1] := 'Play Database';
      smenu^[2] := 'Play Drive';
      smenu^[3] := 'Search Artist';
      smenu^[4] := 'Search Song';
      smenu^[5] := 'Search Album';
      smenu^[6] := 'Browse HD';
      smenu^[7] := 'Back to Main';
      {LoadMenu('Play/Search Menu',7, smenu^);}
      sch := menuselect(smenu^,7);
      dispose(smenu);

      search := sch-2;
      numresults := 0;
      LCDClear;
      for i := 1 to MaxSearch do begin
        Songsearch[i].songnum := 0;
        Songsearch[i].tag := 0;
      end;
      case Sch of
       1: begin
            Help('All songs in the database will be sent to the playlist file MPXTALL.M3U',LCDLines);
            PlayALL;
          end;
       2: begin
            Help('This command plays all of the songs on a selected drive. No Database is needed.',LCDLines);
            PlayDrive;
          end;

        3: begin
             LCDPrintAt(1,ArtistStr+':');
             inp:=input(1,length(ArtistStr)+2);
           end;
        4: begin
             LCDPrintAt(1,SongStr+':');
             inp:=input(1,length(SongStr)+2);
           end;
        5:  begin
             LCDPrintAt(1,AlbumStr+':');
             inp:=input(1,length(albumStr)+2);
           end;
        6: BrowseDrive;
     end;
     if length(inp) > 0 then
     if (Search >= 1) and (Search <=3) then begin
       LCDClear;
       LCDPrintAt(1,LoadingStr+'...');
       DoSearch(Search,inp,Songsearch,numresults);
     end;
     if numresults > 0 then iSong := ScrollPlayList(Songsearch,numresults);
   until sch=7;
end;


procedure SortDatabaseMenu;
  var dbchar:integer;
      dbmenu:^menu;
  begin
      LCDClear;
      LCDCursorOff;
      new(dbmenu);
      dbmenu^[1] := 'Sort by Artist';
      dbmenu^[2] := 'Sort by Album';
      dbmenu^[3] := 'Sort by Title';
      dbmenu^[4] := 'Sort by Path';
      dbmenu^[5] := 'Cancel';
      LoadMenu('SortDatabase Menu',5, dbmenu^);
      dbchar := menuselect(dbmenu^,5);
      dispose(dbmenu);
      if dbchar <> 5 then
      begin
        LCDClear;
        LCDPrintAt(1,center('Sorting...'));
        SortDatabase(dbchar);
      end;
      LCDClear;
  end;

procedure DatabaseMenu;
  var dbchar:integer;
      dbmenu:^menu;
  begin
    repeat
      LCDClear;
      LCDCursorOff;
      new(dbmenu);
      dbmenu^[1] := 'Database Info';
      dbmenu^[2] := 'Browse Songs';
      dbmenu^[3] := 'Add Songs';
      dbmenu^[4] := 'Load Database';
      dbmenu^[5] := 'Save Database';
      dbmenu^[6] := 'Clear Database';
      dbmenu^[7] := 'Sort Database';
      dbmenu^[8] := 'Back to Main';
      LoadMenu('Database Menu',8, dbmenu^);
      dbchar := menuselect(dbmenu^,8);

      dispose(dbmenu);
      case dbchar of
        1: DatabaseInfo;
        2: BrowseSongs;
        3: begin
             Help('This will add songs on disk to the database in memory.',LCDLines);
             AddFiles;
           end;
        4: begin
             Help('This will load a database on disk into memory.',LCDLines);
             PickDatabase;
            end;
        5: begin
             Help('This saves all song in memory to a database file (M3D).',LCDLines);
             PromptSaveDatabase;
           end;
        6: begin
Help('Clearing the database wipes out all songs in memory. All changes made to the database will be lost unless saved.',
LCDLines);
             ClearDatabase;
           end;
        7: begin
             SortDatabaseMenu;
           end;
      end;
    until dbchar = 8;
  end;

procedure SetupMenu;
  var smchar:integer;
      smenu:^menu;
 begin
   repeat
     LCDClear;
     LCDCursorOff;
     new(smenu);
     smenu^[1] := 'Help Boxes:';
     smenu^[2] := 'Use Genres:';
     smenu^[3] := 'Select Genres';
     smenu^[4] := 'Song Maintnence';
     smenu^[5] := 'IR Setup';
     smenu^[6] := 'Back to Main';
     LoadMenu('Setup Menu',6, smenu^);
     if HelpBoxes then smenu^[1] := smenu^[1] + 'Yes' else smenu^[1] := smenu^[1] + 'No';
     if GenreSupport then smenu^[2] := smenu^[2] + 'Yes' else smenu^[2] := smenu^[2] + 'No';
     smchar := menuselect(smenu^,6);
     dispose(smenu);
     case smchar of
       1: HelpBoxes := not HelpBoxes;
       2: GenreSupport := not GenreSupport;
       3: begin
            Help('Tag the Genre Styles that you want to appear in searches.',LCDLines);
            Help('Use + to tag. Press Enter to Exit',LCDLines);
            GenreSelect;
          end;
       4: begin
            Help('This launches an external program defined in the MPXT.CFG file.',LCDLines);
            shell(networkutil);
          end;
       5: IRmenu;
     end;
   until smchar = 6;
   save_settings;
 end;

procedure IRMenu;
  var irchar:integer;
      irmenu:^menu;
 begin
   repeat
     LCDClear;
     LCDCursorOff;
     new(irmenu);
     irmenu^[1] := 'IR Info';
     irmenu^[2] := 'Add a code';
     irmenu^[3] := 'Clear Codes';
     irmenu^[4] := 'Load Codes';
     irmenu^[5] := 'Save Codes';
     irmenu^[6] := 'Back to Setup';
{     LoadMenu('IR Menu',6, irmenu^);}
{P     irmenu^[1] := irmenu^[1] + strr(numcodes);}

     irchar := menuselect(irmenu^,6);
     dispose(irmenu);
     case irchar of
       1: begin
            lcdclear;
            if irfound then
              Info('IR active on com'+strr(IRPort)+'. '+irmpxffn+' holds '+strr(numcodes)+' button codes.',lcdlines) else
            Info('IR not active.',lcdlines);
          end;
       2: IRAddKeys;
       3: IRClearCodes;
       4: IRLoadConfig(GetIRFilename);
       5: IRSaveConfig(GetIRFilename);
     end;
   until irchar = 6;
 end;



procedure PlayListMenu;
  var plchar:integer;
      playmenu:^menu;
 begin
   repeat
     LCDClear;
     LCDCursorOff;
     new(playmenu);
     playmenu^[1] := 'Play List';
     playmenu^[2] := 'Load List';
     playmenu^[3] := 'Edit List';
     playmenu^[4] := 'Save List';
     playmenu^[5] := 'Clear List';
     playmenu^[6] := 'Back to Main';
     LoadMenu('Playlist Menu',6,playmenu^);
     plchar := menuselect(playmenu^,6);
     dispose(playmenu);
{     repeat plchar:=readkey; until (pos(plchar,'123') > 0) or (plchar = #13);}
     case plchar of
       1: PlayPlayList;
       3: EditPlayList;
       2: LoadPLayList;
       4: SavePlayList;
       5: begin
              ClearPlayList;
              LCDClear;
              LCDPrintAt(1,'Playlist Cleared!');
              LCDCursorOn;
              delay(500);
              LCDCursorOff;
            end;

     end
   until plchar = 6;
 end;

procedure CDAudioMenu;
  var cdchar:integer;
      playmenu:^menu;

 begin
   repeat
     LCDClear;
     LCDCursorOff;
     new(playmenu);
     playmenu^[1] := 'Play CD';
     playmenu^[2] := 'Change Disc';
     playmenu^[3] := 'Change Drive';
     playmenu^[4] := 'Back to Main';
     LoadMenu('CDAudio Menu',4,playmenu^);
     cdchar := menuselect(playmenu^,4);
     dispose(playmenu);
     case cdchar of
       1: begin
            CDAudioPlay;
          end;
       2: ChangeCDROM;
       3: EjectCDROM;

     end
   until cdchar = 4;
 end;

begin

end.