Program MPXT;
{$R+,S+,M 60000,0,30000
  Mpxplay eXTended Front End

  Version 1.49-Beta1
  Based on MPXF, by Scott Bradshaw
  Started on 2/99

}

uses dos, mpxfvars,
     crt, lcd,
     XMS,
     keystats,keyintr,mpxfcd,mpxfir,
     config,
{$IFDEF rlogo }reallogo {$ELSE} logo {$ENDIF},
     mpxfmenu,mpxfpl,mpxfgen,mpxfmem,mpxfsrch,mpxfdb,mpxfcprc{$IFDEF inone },mpxftsrb {$ENDIF};




VAR

{ Config File VARS }
  I: LongInt;
  mainch,ch: Char;


procedure BrowseMP3s;
  var s:string;
     c:char;
  begin
    LCDClear;
    LCDPrintAt(1,'Select File:');
    if numlockon then begin
      delay(50);
      Numlock(FALSE);
      storekey(0,ord('a'));
      if keypress then c:=getkey;
      delay(50);
    end;
    s:= mp3prog + ' -bl -ef';
    shell(s);
    NUMLOCK(true);
  end;



procedure dp;
var i:integer;
  begin
    for i := 1 to 10 do writeln(i,')',playlist[i].songnum);
  end;



procedure flush;
  var c:char;
  begin
    while keypress do c:=getkey;
  end;





procedure RandomSong;

  const RandTrack = 15;
  var r:word;
      OldLoop:boolean; { Store Loop settings}
      randstore:array[1..RandTrack] of word;
      randslot:word;
      i:word;
      AlreadyDone:boolean;
  begin
    for r := 1 to RandTrack do randstore[r] := 0;
    OldLoop := loop;
    InitLCD;
    LCDClear;
    LCDCursorOff;
    randslot := 1;
    repeat
      write('Find random song...');
      r := random(totalsongs);
      Loop := False;
      write('check Genre..',r);
      if (SongInGenre(getsonginfo(r))) then
      begin
        write('.found..');
        AlreadyDone := False;
        for i := 1 to RandTrack do if randstore[i] = r then AlreadyDone := true;
        if not AlreadyDone then begin
          writeln('Play!');
          PlaySong(r);
          textcolor(white);
          write('Updating Random Info..');
          for i := 2 to RandTrack do randstore[i-1] := randstore[i];
          randstore[RandTrack] := r;
          writeln('Done.');
        end;
      end;
    until keypress;
    Loop:=OldLoop;
    flush;
    numlock(true);
  end;




procedure MainMenu;

  var mmchar:integer;
      main:^menu;
 begin
   repeat
     Search := 0;
     delay(50);
     InitLCD;
     delay(50);
     LCDClear;
     LCDCursorOff;
     mmchar := 0;
     new(main);
     main^[1] := 'Play/Search';
     main^[2] := 'Playlist Menu';
     main^[3] := 'Database Menu';
     main^[4] := 'CD Audio Menu';
     main^[5] := 'Setup Menu';
     main^[6] := 'Quit MpXT';
     LoadMenu('Main Menu',6,main^);
     mmchar := menuselect(main^,6);
     dispose(main);
     case mmchar of
       1: SearchMenu;
       2: PlayListMenu;
       3: DatabaseMenu;
       4: CDAudioMenu;
       5: begin
            SetupMenu;
            save_settings;
          end;
     end;
   until (mmchar = 6);

 end;


procedure InitializeLCD;
  begin
    ReadLCDSettings;
    LCDLen := width;
    LCDLines := lines;
         delay(50);
     InitLCD;
     delay(50);
     LCDClear;
     LCDCursorOff;

   { InitLCD;}
  end;

procedure WaitTime(t:word);
 var h,s,ss,m,start:word;

  begin
    gettime(h,m,s,ss);
    start := s;
    while(t<>0) do begin
      repeat
        gettime(h,m,s,ss);
      until s<>start;
      start := s;
      dec(t);
    end;
  end;

BEGIN
  DefaultDatabase := DatabaseEmpty;
  debug := paramcount > 1;
  HelpBoxes:=true;
  clrscr;
  gotoxy(1,6);
  writeln('MpXT ',version,' Start');
  randomize;
  numlock(TRUE);
  GenreSupport := False;
  Scrolling:=True;

{
  if not chkintegrity then
    begin
      writeln('MPXF Abnormal Error. Please contact Author.');
      halt(1);
    end;
 }
  if debug then writeln('Open config file..');
  if paramcount < 1 then begin
    if not (openconfig('MPXT.CFG')) then begin
    writeln('Error opening MPXT.CFG');
    halt(1);
    end;
  end else
  if not (openconfig(paramstr(1))) then begin
    writeln('Error opening config file:',paramstr(1));
    halt(1);
  end;
  if debug then Writeln('Define Genres..');
  define_genre;
  define_playoptions;
  if debug then Writeln('Load Settings...');
  load_settings;
  if debug then Writeln('Setup LCD...');
  InitializeLCD;
  if PlayListDir[length(PlayListDir)] <> '\' then begin
    writeln('PlayListDirectory must end in ''\'' !');
    halt;
  end;

  { Draw Logo }
  lcdtoscreen := false;

  if debug then writeln('do logo');
  if (DrawLogo) then
   begin
    writeln('Drawing logo on LCD..');
    drawmpxflogo;
   end
   else
    begin
     lcdclear;
     lcdprintat(1,StartLogo[1]);
     lcdprintat(2,StartLogo[2]);
     if lcdlines > 2 then
      begin
       lcdprintat(3,Startlogo[3]);
       lcdprintat(4,StartLogo[4]);
      end;
    end;
  delay(StartDelay);

  if debug then writeln('Define custom LCD chars');
  if debug then writeln('Clear LCD');

{  lcdcursoroff;}
  { Init }
  lcdtoscreen := true;
  if (UseIR or Usex10) then
  begin
    if debug then writeln('Init IR');
    irclearcodes;
    irloadconfig(irmpxffn);
    irsetport(irport);
    if usex10 then x10start else irstart;
  end;
{  if not debug then lcdclear;}
  if debug then writeln('Draw Init');
  delay(50);
  InitLCD;
  LCDClear;
  LCDPrintAt(1,'Init.');
  if debug then writeln('Init Phone Pad');
  initphone;
  if debug then writeln('Clear Playlist');
  ClearPlayList;
  if debug then writeln('Init XMS');
  Init_Xms;
  if debug then writeln('loading songs');
  TotalSongs := 0;
  if defaultdatabase <> DatabaseEmpty then
    LoadDatabase(defaultdatabase);
  if debug then writeln('done songs');
  lcdcursoroff;
  if CmdEmpty then
  begin
    if not debug then delay(2500);
  end;

  { Do program }
  if debug then writeln('before main');
  if debug then writeln('hit enter to start');
  if debug then readln;
  initcdrom;
  {$IFDEF inone} doit; {$ENDIF}
  lcdtoscreen := true;
  definestars;
  PlayerHalt := false;
  MenuLoop('Start Menu');
{  MainMenu;}
  { Exit Stuff }
  writeln('Exiting...');
  if UseIR or UseX10 then irstop;
  LCDClear;
  LCDToggle;
  LCDCleanUp;
  ReleaseXMS;
  save_settings;
  writeln('MPXT Exited.');
  {$IFDEF inone} shutoff; {$ENDIF}
end.
